import handleArrayCRUD from '../../../utils/handleArrayCRUD';
import { DOT_SERVICE_EVENT_TYPE_SHOW_TOAST_NOTIFICATION, DOT_SERVICE_EVENT_TYPE_HIDE_TOAST_NOTIFICATION, DOT_SERVICE_EVENT_TYPE_CLEAR_ALL_TOAST_NOTIFICATION, DOT_SERVICE_EVENT_TYPE_SHOW_PROMISE_TOAST_NOTIFICATION, DOT_SERVICE_EVENT_TYPE_UPDATE_PROMISE_TOAST_NOTIFICATION, DOT_SERVICE_EVENT_TYPE_HIDE_PROMISE_TOAST_NOTIFICATION } from '../../../service/helpers/constant';
import { DUMMY_ARRAY } from '../../../utils/constants';
const {
  addItem: _showToastNotification,
  removeItem: _hideToastNotification,
  clearItems: _clearToastNotifications,
  updateItemById: _updateToastNotifications,
  getArray: _getToastNotifications
} = handleArrayCRUD();
let toastIdCounter = 0;

const toastNotificationReducer = function () {
  let state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : DUMMY_ARRAY;
  let action = arguments.length > 1 ? arguments[1] : undefined;
  const {
    type,
    payload
  } = action;

  switch (type) {
    case DOT_SERVICE_EVENT_TYPE_SHOW_TOAST_NOTIFICATION:
      {
        const id = `toast${toastIdCounter++}`;
        const toastMessage = {
          id,
          data: payload
        };

        _showToastNotification(toastMessage);

        return _getToastNotifications();
      }

    case DOT_SERVICE_EVENT_TYPE_HIDE_TOAST_NOTIFICATION:
      {
        _hideToastNotification(payload.id);

        return _getToastNotifications();
      }

    case DOT_SERVICE_EVENT_TYPE_CLEAR_ALL_TOAST_NOTIFICATION:
      {
        _clearToastNotifications();

        return _getToastNotifications();
      }

    case DOT_SERVICE_EVENT_TYPE_SHOW_PROMISE_TOAST_NOTIFICATION:
      {
        _showToastNotification(payload);

        return _getToastNotifications();
      }

    case DOT_SERVICE_EVENT_TYPE_UPDATE_PROMISE_TOAST_NOTIFICATION:
      {
        _updateToastNotifications(payload.id, payload);

        return _getToastNotifications();
      }

    case DOT_SERVICE_EVENT_TYPE_HIDE_PROMISE_TOAST_NOTIFICATION:
      {
        _hideToastNotification(payload.id);

        return _getToastNotifications();
      }

    default:
      console.error('No such service found in DOT Toast Notification Service');
      return state;
  }
};

export default toastNotificationReducer;