"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _handleArrayCRUD2 = _interopRequireDefault(require("../../../utils/handleArrayCRUD"));

var _constant = require("../../../service/helpers/constant");

var _constants = require("../../../utils/constants");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var _handleArrayCRUD = (0, _handleArrayCRUD2["default"])(),
    _showToastNotification = _handleArrayCRUD.addItem,
    _hideToastNotification = _handleArrayCRUD.removeItem,
    _clearToastNotifications = _handleArrayCRUD.clearItems,
    _updateToastNotifications = _handleArrayCRUD.updateItemById,
    _getToastNotifications = _handleArrayCRUD.getArray;

var toastIdCounter = 0;

var toastNotificationReducer = function toastNotificationReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _constants.DUMMY_ARRAY;
  var action = arguments.length > 1 ? arguments[1] : undefined;
  var type = action.type,
      payload = action.payload;

  switch (type) {
    case _constant.DOT_SERVICE_EVENT_TYPE_SHOW_TOAST_NOTIFICATION:
      {
        var id = "toast".concat(toastIdCounter++);
        var toastMessage = {
          id: id,
          data: payload
        };

        _showToastNotification(toastMessage);

        return _getToastNotifications();
      }

    case _constant.DOT_SERVICE_EVENT_TYPE_HIDE_TOAST_NOTIFICATION:
      {
        _hideToastNotification(payload.id);

        return _getToastNotifications();
      }

    case _constant.DOT_SERVICE_EVENT_TYPE_CLEAR_ALL_TOAST_NOTIFICATION:
      {
        _clearToastNotifications();

        return _getToastNotifications();
      }

    case _constant.DOT_SERVICE_EVENT_TYPE_SHOW_PROMISE_TOAST_NOTIFICATION:
      {
        _showToastNotification(payload);

        return _getToastNotifications();
      }

    case _constant.DOT_SERVICE_EVENT_TYPE_UPDATE_PROMISE_TOAST_NOTIFICATION:
      {
        _updateToastNotifications(payload.id, payload);

        return _getToastNotifications();
      }

    case _constant.DOT_SERVICE_EVENT_TYPE_HIDE_PROMISE_TOAST_NOTIFICATION:
      {
        _hideToastNotification(payload.id);

        return _getToastNotifications();
      }

    default:
      console.error('No such service found in DOT Toast Notification Service');
      return state;
  }
};

var _default = toastNotificationReducer;
exports["default"] = _default;